#line 1 "C:/Users/Public/Documents/Mikroelektronika/mikroC PRO for PIC32/Examples/Development Systems/PIC32MX7_MMB/Ethernet Demo/Ethernet_Demo_events_code.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/examples/development systems/pic32mx7_mmb/ethernet demo/ethernet_demo_objects.h"
typedef struct Screen TScreen;

typedef struct Label {
 char Order;
 TScreen *OwnerScreen;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Pos_Ver;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Image {
 TScreen *OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 unsigned int PictureWidth;
 unsigned int PictureHeight;
 const char *Picture_Name;
 char Visible;
 char Active;
 char AutoSize;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef struct Circle {
 TScreen *OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int LabelsCount;
 TLabel **Labels;
 unsigned int ImagesCount;
 TImage **Images;
 unsigned int CirclesCount;
 TCircle **Circles;
};

extern TScreen Screen1;
extern TLabel Label1;
extern TImage Image1;
extern TCircle Circle1;
extern TCircle Circle2;
extern TCircle Circle3;
extern TCircle Circle4;
extern TCircle Circle5;
extern TCircle Circle6;
extern TCircle Circle7;
extern TCircle Circle8;




void Circle1Click();
void Circle2Click();
void Circle3Click();
void Circle4Click();
void Circle5Click();
void Circle6Click();
void Circle7Click();
void Circle8Click();




extern char Label1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *Alabel);
void DrawImage(TImage *Aimage);
void DrawCircle(TCircle *Acircle);
void Check_TP();
void Start_TP();
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/examples/development systems/pic32mx7_mmb/ethernet demo/ethernet_demo_resources.h"
const code char Impact26x39[];
const code char Image1_mikroe_logo[13073];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/examples/development systems/pic32mx7_mmb/ethernet demo/__ethernet.h"
#line 4 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/examples/development systems/pic32mx7_mmb/ethernet demo/__ethernet.h"
typedef struct
 {
 unsigned char valid;
 unsigned long tmr;
 unsigned char ip[4];
 unsigned char mac[6];
 } Ethernet_arpCacheStruct;

extern Ethernet_arpCacheStruct Ethernet_arpCache[];

extern unsigned char Ethernet_macAddr[6];
extern unsigned char Ethernet_ipAddr[4];
extern unsigned char Ethernet_gwIpAddr[4];
extern unsigned char Ethernet_ipMask[4];
extern unsigned char Ethernet_dnsIpAddr[4];
extern unsigned char Ethernet_rmtIpAddr[4];

extern unsigned long Ethernet_userTimerSec;

typedef struct {
 unsigned canCloseTCP: 1;
 unsigned isBroadcast: 1;
} TEthPktFlags;
#line 31 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/examples/development systems/pic32mx7_mmb/ethernet demo/__ethernet.h"
extern void Ethernet_Init(unsigned char *mac, unsigned char *ip, unsigned long configuration);
extern unsigned char Ethernet_doPacket();
extern void Ethernet_putByte(unsigned char b);
extern void Ethernet_putBytes(unsigned char *ptr, unsigned int n);
extern void Ethernet_putConstBytes(const unsigned char *ptr, unsigned int n);
extern unsigned char Ethernet_getByte();
extern void Ethernet_getBytes(unsigned char *ptr, unsigned long addr, unsigned int n);
extern unsigned int Ethernet_UserUDP(unsigned char *remoteHost, unsigned int remotePort, unsigned int localPort, unsigned int reqLength, TEthPktFlags * flags);
extern unsigned int Ethernet_UserTCP(unsigned char *remoteHost, unsigned int remotePort, unsigned int localPort, unsigned int reqLength, TEthPktFlags * flags);
extern void Ethernet_confNetwork(char *ipMask, char *gwIpAddr, char *dnsIpAddr);
#line 9 "C:/Users/Public/Documents/Mikroelektronika/mikroC PRO for PIC32/Examples/Development Systems/PIC32MX7_MMB/Ethernet Demo/Ethernet_Demo_events_code.c"
const code unsigned char httpHeader[] = "HTTP/1.1 200 OK\nContent-type: ";
const code unsigned char httpMimeTypeHTML[] = "text/html\n\n";
const code unsigned char httpMimeTypeScript[] = "text/plain\n\n";
unsigned char httpMethod[] = "GET /";
#line 19 "C:/Users/Public/Documents/Mikroelektronika/mikroC PRO for PIC32/Examples/Development Systems/PIC32MX7_MMB/Ethernet Demo/Ethernet_Demo_events_code.c"
const code char *indexPage =
#line 30 "C:/Users/Public/Documents/Mikroelektronika/mikroC PRO for PIC32/Examples/Development Systems/PIC32MX7_MMB/Ethernet Demo/Ethernet_Demo_events_code.c"
"<meta http-equiv=\"refresh\" content=\"3;url=http://192.168.20.60\"><HTML><HEAD></HEAD><BODY><h1>PIC32 Ethernet Mini Web Server</h1><a href=/>Reload</a><script src=/s></script><table><tr><td valign=top></td><td>" ;
#line 47 "C:/Users/Public/Documents/Mikroelektronika/mikroC PRO for PIC32/Examples/Development Systems/PIC32MX7_MMB/Ethernet Demo/Ethernet_Demo_events_code.c"
const code char *indexPage2 = "</td><td><table border=1 style=\"font-size:20px ;font-family: terminal ;\"><tr><th colspan=3>LED</th></tr><script>var str,i;str=\"\";for(i=0;i<8;i++){str+=\"<tr><td bgcolor=yellow>LED #\"+i+\"</td>\";if(PORTD&(1<<i)){str+=\"<td bgcolor=red>ON\";}else {str+=\"<td bgcolor=#cccccc>OFF\";}str+=\"</td><td><a href=/t\"+i+\">Toggle</a></td></tr>\";}document.write(str) ;</script></table></td></tr></table>This is HTTP request #<script>document.write(REQ)</script></BODY></HTML>" ;



unsigned char myMacAddr[6] = {0x00, 0x14, 0xA5, 0x76, 0x19, 0x3f};
unsigned char myIpAddr[4] = {192, 168, 20, 60 };
unsigned char gwIpAddr[4] = {192, 168, 20, 6 };
unsigned char ipMask[4] = {255, 255, 255, 0 };
unsigned char dnsIpAddr[4] = {192, 168, 20, 1 };

unsigned char getRequest[15];
unsigned char dyna[31] ;
unsigned long httpCounter = 0;

unsigned int Ethernet_UserUDP(unsigned char *remoteHost, unsigned int remotePort, unsigned int destPort, unsigned int reqLength, TEthPktFlags *flags)
 {
 unsigned int len;


 ByteToStr(remoteHost[0], dyna);
 dyna[3] = '.';
 ByteToStr(remoteHost[1], dyna + 4);
 dyna[7] = '.';
 ByteToStr(remoteHost[2], dyna + 8);
 dyna[11] = '.';
 ByteToStr(remoteHost[3], dyna + 12);

 dyna[15] = ':';


 WordToStr(remotePort, dyna + 16);
 dyna[21] = '[';
 WordToStr(destPort, dyna + 22);
 dyna[27] = ']';
 dyna[28] = 0;


 len = 28 + reqLength;


 Ethernet_putBytes(dyna, 28);


 while(reqLength--)
 {
 Ethernet_putByte(toupper(Ethernet_getByte()));
 }

 return(len);
 }


char CircleColor = 0;

void TogleCircle(TCircle *Acircle){
 if(Acircle->color == CL_WHITE)
 Acircle->color = CL_RED;
 else
 Acircle->color = CL_WHITE;
 DrawCircle(Acircle);
}

void ToggleC(char num){
char cc;
 switch(num){
 case 0 : TogleCircle(&Circle1); break;
 case 1 : TogleCircle(&Circle2); break;
 case 2 : TogleCircle(&Circle3); break;
 case 3 : TogleCircle(&Circle4); break;
 case 4 : TogleCircle(&Circle5); break;
 case 5 : TogleCircle(&Circle6); break;
 case 6 : TogleCircle(&Circle7); break;
 case 7 : TogleCircle(&Circle8); break;
 }
 cc = 1 << num;
 CircleColor = CircleColor ^ cc;
}


unsigned int Ethernet_UserTCP(unsigned char *remoteHost, unsigned int remotePort, unsigned int localPort, unsigned int reqLength, TEthPktFlags *flags)
 {
 unsigned int len;






 if(localPort != 80)
 {
 return(0);
 }


 for(len = 0; len < 10; len++)
 {
 getRequest[len] = Ethernet_getByte();
 }
 getRequest[len] = 0;
 len = 0;

 if(memcmp(getRequest, httpMethod, 5))
 {
 return(0);
 }

 httpCounter++;

 if(getRequest[5] == 's')
 {



 len = Ethernet_putConstString(httpHeader);
 len += Ethernet_putConstString(httpMimeTypeScript);


 len += Ethernet_putConstString("var PORTD=");
 WordToStr(CircleColor, dyna);
 len += Ethernet_putString(dyna);
 len += Ethernet_putConstString(";");


 WordToStr(httpCounter, dyna);
 len += Ethernet_putConstString("var REQ=");
 len += Ethernet_putString(dyna);
 len += Ethernet_putConstString(";");
 }
 else if(getRequest[5] == 't')
 {
 unsigned long bitMask = 0;

 if(isdigit(getRequest[6]))
 {
 bitMask = getRequest[6] - '0';
 ToggleC(bitMask);
 }
 }

 if(len == 0)
 {
 len = Ethernet_putConstString(httpHeader);
 len += Ethernet_putConstString(httpMimeTypeHTML);
 len += Ethernet_putConstString(indexPage);
 len += Ethernet_putConstString(indexPage2);
 }

 return(len);
 }

void InitPHYPins(){
 TRISD11_bit = 0;
 TRISD8_bit = 1;

 TRISA15_bit = 0;
 TRISD14_bit = 0;
 TRISD15_bit = 0;

 TRISG9_bit = 1;
 TRISG8_bit = 1;
 TRISE8_bit = 1;
 TRISE9_bit = 1;
 TRISG15_bit = 1;
}







void Circle1Click() {
 TogleCircle(&Circle1);
 CircleColor = CircleColor ^ (1 << 0);
}

void Circle2Click() {
 TogleCircle(&Circle2);
 CircleColor = CircleColor ^ (1 << 1);
}

void Circle3Click() {
 TogleCircle(&Circle3);
 CircleColor = CircleColor ^ (1 << 2);
}

void Circle4Click() {
 TogleCircle(&Circle4);
 CircleColor = CircleColor ^ (1 << 3);
}

void Circle5Click() {
 TogleCircle(&Circle5);
 CircleColor = CircleColor ^ (1 << 4);
}

void Circle6Click() {
 TogleCircle(&Circle6);
 CircleColor = CircleColor ^ (1 << 5);
}

void Circle7Click() {
 TogleCircle(&Circle7);
 CircleColor = CircleColor ^ (1 << 6);
}

void Circle8Click() {
 TogleCircle(&Circle8);
 CircleColor = CircleColor ^ (1 << 7);
}
